#! /bin/sh
# Copyright (c) 1995-2004 SUSE Linux AG, Nuernberg, Germany.
# All rights reserved.
#
# Author: Stanislav Brabec
# Please send feedback to http://www.suse.de/feedback/
#
# /etc/init.d/jabberd
#   and its symbolic link
# /usr/sbin/rcjabberd
#
#    This program is free software; you can redistribute it and/or modify 
#    it under the terms of the GNU General Public License as published by 
#    the Free Software Foundation; either version 2 of the License, or 
#    (at your option) any later version. 
# 
#    This program is distributed in the hope that it will be useful, 
#    but WITHOUT ANY WARRANTY; without even the implied warranty of 
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
#    GNU General Public License for more details. 
# 
#    You should have received a copy of the GNU General Public License 
#    along with this program; if not, write to the Free Software 
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Template system startup script for some example service/daemon jabberd
#
# LSB compatible service control script; see http://www.linuxbase.org/spec/
# 
# Note: This template uses functions rc_XXX defined in /etc/rc.status on
# UnitedLinux (UL) based Linux distributions. If you want to base your 
# script on this template and ensure that it works on non UL based LSB 
# compliant Linux distributions, you either have to provide the rc.status
# functions from UL or change the script to work without them.
#
### BEGIN INIT INFO
# Provides:          jabberd
# Required-Start:    $syslog $network
# Should-Start:
# Required-Stop:     $syslog $network
# Should-Stop:
# Default-Start:     3 5
# Default-Stop:      0 1 2 6
# Short-Description: jabberd XYZ daemon providing ZYX
# Description:       Start jabberd to allow XY and provide YZ
#	continued on second line by '#<TAB>'
#	should contain enough info for the runlevel editor
#	to give admin some idea what this service does and
#	what it's needed for ...
#	(The Short-Description should already be a good hint.)
### END INIT INFO
# 
# Any extensions to the keywords given above should be preceeded by 
# X-VendorTag- (X-UnitedLinux- X-SuSE- for us) according to LSB.
# 
# Notes on Required-Start/Should-Start:
# * There are two different issues that are solved by Required-Start
#    and Should-Start
# (a) Hard dependencies: This is used by the runlevel editor to determine
#     which services absolutely need to be started to make the start of
#     this service make sense. Example: nfsserver should have
#     Required-Start: $portmap
#     Also, required services are started before the dependent ones.
#     The runlevel editor will warn about such missing hard dependencies
#     and suggest enabling. During system startup, you may expect an error,
#     if the dependency is not fulfilled.
# (b) Specifying the init script ordering, not real (hard) dependencies.
#     This is needed by insserv to determine which service should be
#     started first (and at a later stage what services can be started
#     in parallel). The tag Should-Start: is used for this.
#     It tells, that if a service is available, it should be started
#     before. If not, never mind.
# * When specifying hard dependencies or ordering requirements, you can 
#   use names of services (contents of their Provides: section)
#   or pseudo names starting with a $. The following ones are available
#   according to LSB (1.1):
#	$local_fs		all local file systems are mounted
#				(most services should need this!)
#	$remote_fs		all remote file systems are mounted
#				(note that /usr may be remote, so
#				 many services should Require this!)
#	$syslog			system logging facility up
#	$network		low level networking (eth card, ...)
#	$named			hostname resolution available
#	$netdaemons		all network daemons are running
#   The $netdaemons pseudo service has been removed in LSB 1.2.
#   For now, we still offer it for backward compatibility.
#   These are new (LSB 1.2):
#	$time			the system time has been set correctly	
#	$portmap		SunRPC portmapping service available
#   UnitedLinux extensions:
#	$ALL			indicates that a script should be inserted
#				at the end
# * The services specified in the stop tags 
#   (Required-Stop/Should-Stop)
#   specify which services need to be still running when this service
#   is shut down. Often the entries there are just copies or a subset 
#   from the respective start tag.
# * Should-Start/Stop are now part of LSB as of 2.0,
#   formerly SUSE/Unitedlinux used X-UnitedLinux-Should-Start/-Stop.
#   insserv does support both variants.
# * X-UnitedLinux-Default-Enabled: yes/no is used at installation time
#   (%fillup_and_insserv macro in %post of many RPMs) to specify whether
#   a startup script should default to be enabled after installation.
#   It's not used by insserv.
#
# Note on runlevels:
# 0 - halt/poweroff 			6 - reboot
# 1 - single user			2 - multiuser without network exported
# 3 - multiuser w/ network (text mode)  5 - multiuser w/ network and X11 (xdm)
# 
# Note on script names:
# http://www.linuxbase.org/spec/refspecs/LSB_1.3.0/gLSB/gLSB/scrptnames.html
# A registry has been set up to manage the init script namespace.
# http://www.lanana.org/
# Please use the names already registered or register one or use a
# vendor prefix.

# Source LSB init functions
# providing start_daemon, killproc, pidofproc, 
# log_success_msg, log_failure_msg and log_warning_msg.
# This is currently not used by UnitedLinux based distributions and
# not needed for init scripts for UnitedLinux only. If it is used,
# the functions from rc.status should not be sourced or used.
#. /lib/lsb/init-functions

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     be verbose in local rc status and clear it afterwards
#      rc_status -v -r  ditto and clear both the local and overall rc status
#      rc_status -s     display "skipped" and exit with status 3
#      rc_status -u     display "unused" and exit with status 3
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num>
#      rc_reset         clear both the local and overall rc status
#      rc_exit          exit appropriate to overall rc status
#      rc_active        checks whether a service is activated by symlinks
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0	  - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

#!/bin/bash
#
# Raymond 25DEC2003 support@bigriverinfotech.com
# /etc/rc.d/init.d/jabberd2
# init script for jabberd2 processes
# Tested under jabberd-2.0rc2 and Fedora 1.0 only
#
# processname: jabberd2
# description: jabberd2 is the next generation of the jabberd server
# chkconfig: 2345 85 15
#
progs="router resolver sm c2s s2s"
progsPath="/usr/bin"
confPath="/etc/jabberd"
pidPath="/var/lib/jabberd/pid"
retval=0
#
StatusOK ( ) {
	rc_status -v
}
#
StatusFailed ( ) {
	rc_failed
	rc_status -v
}
#
ReqBins ( ) {
	for prog in ${progs}; do
		if [ ! -x ${progsPath}/${prog} ]; then
			echo -n "jabberd binary [${prog}] not found."
# Note: Special treatment of stop for LSB conformance
			if [ "$1" = "stop" ]; then exit 0; else exit 5; fi
		fi
	done
	return 0
}
#
ReqConfs ( ) {
	for prog in ${progs}; do
		if [ ! -f ${confPath}/${prog}.xml ]; then
			echo -n "jabberd configuration [${prog}.xml] not found."
			if [ "$1" = "stop" ]; then exit 0; else exit 6; fi
		fi
	done
	return 0
}
#
ReqDirs ( ) {
	if [ ! -d ${pidPath} ]; then
		echo -n "jabberd PID directory not found. Cannot continue."
		StatusFailed
		return -1
	fi
	return 0
}
#
Start ( ) {
	for req in ReqBins ReqConfs ReqDirs; do
		${req}
		retval=$?
		[ ${retval} == 0 ] || return ${retval}
	done
	echo "Initializing jabberd processes..."
	for prog in ${progs}; do
		if [ $( pidof -s ${prog} ) ]; then
			echo -ne "\tprocess [${prog}] already running"
			StatusFailed
			sleep 1
			continue
		fi
		echo -ne "\tStarting ${prog} "
		if [ ${prog} == "router" ]; then
			ports="5347"
		elif [ ${prog} == "c2s" ]; then
			ports="5222 5223"
		elif [ ${prog} == "s2s" ]; then
			ports="5269"
		else
			ports=""
		fi
		for port in ${ports}; do
			if [ $( netstat --numeric-ports --listening --protocol=inet |
	 				gawk '{ print $4 }' |
						gawk -F : '{ print $NF }' |
							grep -c ${port}$ ) -ne "0" ]; then
				StatusFailed
				echo -e "\tPort ${port} is currently in use. Cannot continue"
				echo -e "\tIs a Jabber 1.x server running?"
				Stop
				let retval=1
				break 2
			fi
		done		
		rm -f /var/lock/subsys/${prog}
		rm -f ${pidPath}/${prog}.pid
		args="-c ${confPath}/${prog}.xml"
		${progsPath}/${prog} ${args} & 2> /dev/null
		retval=$?
		if [ ${retval} == 0 ]; then
			StatusOK
			touch /var/lock/subsys/${prog}
		else
			StatusFailed
			Stop
			let retval=1
			break
		fi
		sleep 1
	done
	return ${retval}
}
#
Stop ( ) {
	echo "Terminating jabberd processes..."
	for prog in ${progs}; do
		echo -ne "\tStopping ${prog} "
		killproc ${prog}
		retval=$?
		if [ ${retval} == 0 ]; then
			StatusOK
			rm -f /var/lock/subsys/${prog}
			rm -f ${pidPath}/${prog}.pid
		else
			StatusFailed
		fi
		sleep 1
	done
	return ${retval}
}
#
case "$1" in
	start)
		Start
		;;
	stop)
		Stop
		;;
	restart)
		Stop
		Start
		;;
	try-restart|condrestart|reload)
		if [ -f /var/lock/subsys/${prog} ]; then
			Stop
			sleep 3
			Start
		fi
		;;
	status)
		rc_failed 4
		rc_status -v
		;;
	probe)
		echo reload
		;;
	*)
		echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
		let retval=1
esac
#exit ${retval}
rc_exit
#
# eof
